Subject: Confused about `git gc`

From: Yakup Akbay <[email-masked]>
Date: Tue, 09 Jun 2009 11:28:39 +0300

Looks like I didn't quite understand the actual role of `git gc`. I just 
thought that `git gc` would remove all unreferenced objects during the 
unpack-pack process. However, I'm not seeing the result what I was 
expecting from `git gc`.

I'm adding an object into the database, which is ignored by git. Then I 
expect the object to be removed after `git gc`. But, it's still there.

Please follow:

$ echo "/ignored_file" > .gitignore
$ echo "This file is ignored by git. I'm sure that this content has 
never been existed in the repository before." > ignored_file
$ git hash-object -w ignored_file
39cd40a92c0a92bbcbd74ec6879b4936212beebd
$ ls .git/objects/
07  39  9f  b9  d0  fa  info  pack
$ ls .git/objects/39/
cd40a92c0a92bbcbd74ec6879b4936212beebd
$ git gc
Counting objects: 319, done.
Delta compression using up to 2 threads.
Compressing objects: 100% (147/147), done.
Writing objects: 100% (319/319), done.
Total 319 (delta 124), reused 319 (delta 124)
$ ls .git/objects/39/
cd40a92c0a92bbcbd74ec6879b4936212beebd

As you see, 39cd40a92c0a92bbcbd74ec6879b4936212beebd is still there. 
Shouldn't it be removed by `git gc`?

What am I overlooking?

Regards,
Yakup